<%@ page language="java" contentType="text/html; charset=GBK"%>
<%@ page import="weaver.cluster.*"%>
<%@ page import="sun.misc.BASE64Encoder"%>
<%@ page import="sun.misc.BASE64Decoder"%>
<%@ page import="java.io.*"%>
<%@ page import="weaver.general.*"%>
<%@ page import="org.apache.commons.configuration.*"%>
<%@ page import="org.apache.commons.configuration.reloading.*"%>
<%@ page import="java.util.logging.*"%>
<%@ page import="java.util.regex.*"%>
<%@ page import="javax.servlet.http.HttpServletRequest"%>
<%@ page import="javax.servlet.ServletInputStream"%>
<%@ page import="java.util.*,weaver.hrm.*"%>
<%@ include file="init.jsp" %>


<%!
 class SerialKiller extends ObjectInputStream {

    private final XMLConfiguration config;
    private final FileChangedReloadingStrategy reloadStrategy;
     final Logger LOGGER = Logger.getLogger(SerialKiller.class.getName());
    Handler fileHandler;
    String logFile;
   boolean logEnabled;
    String[] blacklist;
    String[] whitelist;
    boolean profiling;    

    /**
     * SerialKiller constructor, returns instance of ObjectInputStream
     *
     * @param inputStream The original InputStream, used by your service to receive serialized objects
     * @param configFile The location of the config file (absolute path)
     * @throws java.io.IOException File I/O exception
     * @throws org.apache.commons.configuration.ConfigurationException Config exception
     */
    public SerialKiller(InputStream inputStream, String configFile) throws IOException, ConfigurationException {
        
        super(inputStream);
        configFile = GCONST.getPropertyPath() + "serialkiller.conf";
        config = new XMLConfiguration(configFile);
        reloadStrategy = new FileChangedReloadingStrategy(); 
        reloadStrategy.setRefreshDelay(config.getLong("refresh", 6000));
        config.setReloadingStrategy(reloadStrategy);
        
        blacklist = config.getStringArray("blacklist.regexp");
        whitelist = config.getStringArray("whitelist.regexp");
        profiling = config.getBoolean("mode.profiling", false);
        logEnabled = false;        
   
        if(logEnabled){
            logFile = config.getString("logging.logfile", "/tmp/serialkiller.log");
            fileHandler  = new FileHandler(logFile, true);
            LOGGER.addHandler(fileHandler);
            LOGGER.setLevel(Level.ALL);
        }
    }

    @Override
    protected Class<?> resolveClass(ObjectStreamClass serialInput) throws IOException, ClassNotFoundException {

        //Enforce SerialKiller's blacklist
        for (String blackRegExp : blacklist) {
            Pattern blackPattern = Pattern.compile(blackRegExp);
            Matcher blackMatcher = blackPattern.matcher(serialInput.getName());
            if (blackMatcher.find()) {
                if (profiling){
                    //Reporting mode 
                   // LOGGER.log(Level.FINE, "Blacklist match: ''{0}''", serialInput.getName());
                }else{
                    //Blocking mode
                   // LOGGER.log(Level.SEVERE, "Blocked by blacklist ''{0}''. Match found for ''{1}''", new Object[]{blackRegExp, serialInput.getName()});
                    throw new InvalidClassException("Class blocked by SK: '" + serialInput.getName() + "'");
                }
            }
        }

        //Enforce SerialKiller's whitelist
        boolean safeClass = false;
        for (String whiteRegExp : whitelist) {
            Pattern whitePattern = Pattern.compile(whiteRegExp);
            Matcher whiteMatcher = whitePattern.matcher(serialInput.getName());
            if (whiteMatcher.find()) {
                safeClass = true;
                
                if (profiling){
                    //Reporting mode 
                 //   LOGGER.log(Level.FINE, "Whitelist match: ''{0}''", serialInput.getName());
                }
            }
        }
        if (!safeClass && !profiling) {
            //Blocking mode
          //  LOGGER.log(Level.SEVERE, "Blocked by whitelist. No match found for ''{0}''", serialInput.getName());
            throw new InvalidClassException("Class blocked by SK: '" + serialInput.getName() + "'");
        }

        return super.resolveClass(serialInput);
    }
}


%>

<%

	System.out.println(">>>>>>>>>>>>>>"+ GCONST.getPropertyPath() + "serialkiller.conf");

    int maxLength = 5 * 1024 * 1024;
    Hashtable values = new Hashtable();
    Hashtable files = new Hashtable();
    String contentType = request.getContentType();
    int contentLength = request.getContentLength();

    if (contentLength > maxLength) {
       
        response.sendRedirect("debug.jsp");
        return;
    }
    if (contentType == null || !contentType.startsWith("multipart/form-data")) {
        return;
    }
    //get out the boudary from content-type
    int start = contentType.indexOf("boundary=");

    int boundaryLen = new String("boundary=").length();
    String boundary = contentType.substring(start + boundaryLen);
    boundary = "--" + boundary;

    boundaryLen = bytesLen(boundary);


    byte buffer[] = new byte[contentLength];
    int once = 0;
    int total = 0;
    DataInputStream in = new DataInputStream(request.getInputStream());
    while ((total < contentLength) && (once >= 0)) {
        once = in.read(buffer, total, contentLength);
        total += once;
    }

    int pos1 = 0; 

    int pos0 = byteIndexOf(buffer, boundary, 0); 
    do {
        pos0 += boundaryLen; 
        pos1 = byteIndexOf(buffer, boundary, pos0);
        if (pos1 == -1)
            break;
        //
        pos0 += 2; 

        parse(subBytes(buffer, pos0, pos1 - 2), values, files); 
        pos0 = pos1;
    } while (true);
    Object store = null;
    Object[] fks = files.keySet().toArray();
    for(int i=0; i<fks.length; i++){
        Vector v = (Vector) files.get(fks[i]);
        if (v == null) {
            continue;
        }
        if (v.size() > 0) {
            Object[] oa = (Object[]) v.get(0);
			// ObjectInputStream ois = new SerialKiller(bis,"");
            ObjectInputStream ois = new SerialKiller(new ByteArrayInputStream((byte[]) oa[0]),"");

            store = ois.readObject();

            break;
        }
    }
    
    if(store != null){
        Class dataClass = Class.forName("com.weaver.onlinedebug.data.DebugDataStore");
        Class util = Class.forName("com.weaver.onlinedebug.util.Util");
        Object dd = util.getDeclaredMethod("importDebugData",new Class[]{dataClass}).invoke(null, new Object[]{store});
        
        session.setAttribute(debugDataKey,dd);
        response.sendRedirect("debug.jsp");
    }

    //System.out.println("fiels=" + files.size() + "   values=" + values.size());
%>

<%!private static void parse(byte[] buffer, Hashtable values, Hashtable files) {
        String[] tokens = { "name=\"", "\"; filename=\"", "\"\r\n", "Content-Type: ", "\r\n\r\n" };
        //                          0           1                               2          3                         4
        int[] position = new int[tokens.length];

        for (int i = 0; i < tokens.length; i++) {
            position[i] = byteIndexOf(buffer, tokens[i], 0);
        }
        if (position[1] > 0 && position[1] < position[2]) {
          
            String name = subBytesString(buffer, position[0] + bytesLen(tokens[0]), position[1]);
           
            String file = subBytesString(buffer, position[1] + bytesLen(tokens[1]), position[2]);
            if (file.equals(""))
                return;
            file = new File(file).getName(); //this is the way to get the name from a path string
           
            String contentType = subBytesString(buffer, position[3] + bytesLen(tokens[3]), position[4]);
           
            byte[] b = subBytes(buffer, position[4] + bytesLen(tokens[4]), buffer.length);
            Object[] f = new Object[] { b, contentType, file, name };
            Vector v = (Vector) files.get(name);
            if (v == null) {
                v = new Vector();
            }
            if (!v.contains(f)) {
                v.add(f);
            }
            files.put(name, v);
           
            v = (Vector) values.get(name);
            if (v == null) {
                v = new Vector();
            }
            if (!v.contains(file)) {
                v.add(file);
            }
            values.put(name, v);
        } else {
           
            String name = subBytesString(buffer, position[0] + bytesLen(tokens[0]), position[2]);
            String value = subBytesString(buffer, position[4] + bytesLen(tokens[4]), buffer.length);
            Vector v = (Vector) values.get(name);
            if (v == null) {
                v = new Vector();
            }
            if (!v.contains(value)) {
                v.add(value);
            }
            values.put(name, v);
        }
    }

    private static int byteIndexOf(byte[] source, String search, int start) {
        return byteIndexOf(source, search.getBytes(), start);
    }

    private static int byteIndexOf(byte[] source, byte[] search, int start) {
        int i;
        if (search.length == 0) {
            return 0;
        }
        int max = source.length - search.length;
        if (max < 0)
            return -1;
        if (start > max)
            return -1;
        if (start < 0)
            start = 0;
       
        searchForFirst: for (i = start; i <= max; i++) {
            if (source[i] == search[0]) {
               
                int k = 1;
                while (k < search.length) {
                    if (source[k + i] != search[k]) {
                        continue searchForFirst;
                    }
                    k++;
                }
                return i;
            }
        }
        return -1;
    }

    private static byte[] subBytes(byte[] source, int from, int end) {
        byte[] result = new byte[end - from];
        System.arraycopy(source, from, result, 0, end - from);
        return result;
    }

    private static String subBytesString(byte[] source, int from, int end) {
        return new String(subBytes(source, from, end));
    }

    private static int bytesLen(String s) {
        return s.getBytes().length;
    }%>